#ifndef BASICCOMPONENT_H
#define BASICCOMPONENT_H
#include <systemc.h>

enum basicComponent{OR, AND};

class BasicComponent : public sc_module
{
public:
	sc_in<bool>* input;
	sc_out<bool> output;
	SC_HAS_PROCESS(BasicComponent);
	int inputs;
	basicComponent component;
	BasicComponent(sc_module_name name, int inputs, basicComponent component) :
		output("output")
	{
		this->inputs = inputs;
		this->input = new sc_in<bool>[inputs];
		this->component = component;
		SC_METHOD(UPDATE);
		for(int i = 0; i < inputs; i++)
		{
			sensitive << input[i];
		}
	}

	void UPDATE()
	{
		switch(this->component)
		{
		case OR:
			this->output.write(false);
			for(int i = 0; i < this->inputs; i++)
			{
				if(this->input[i].read() == true)
				{
					this->output.write(true);
					break;
				}
			}
			break;
		case AND:
			this->output.write(true);
			for(int i = 0; i < this->inputs; i++)
			{
				if(this->input[i].read() == false)
				{
					this->output.write(false);
					break;
				}
			}
			break;
		}
	}
};

#endif //BASICCOMPONENT_H
