% the function arrange extrinsic information in the memory for collision 
% free access by symbol and check nodes
% empty squares are marked by zeros

function memory = ArrangeDataTarable(constraint1, constraint2)
edges = size(constraint1);
p = edges(1,2);
l = edges(1,1);
edges = l * p;
solution = zeros(edges,3);
free_pos_of_constraints = zeros(l,2);
edge_weight = zeros(p*l,2);
best_solution = zeros(1,edges+1);
memory = zeros(size(constraint1));
hist = zeros(1,p);

for k = 1:edges,
    [row,col] = find(constraint1==k);
    solution(k,1) = row;
    [row,col] = find(constraint2==k);
    solution(k,2) = row;
end

edge_stack = zeros(p*l,4);

for i = 1:l
    free_pos_of_constraints(i,2) = p;
    free_pos_of_constraints(i,1) = p;
end
for i = 1:l*p
    edge_weight(i, 1) = i;
end

edge = constraint1(1,1);
edge_stack(1, 1) = edge;
index_constraint1 = solution(edge,1);
index_constraint2 = solution(edge,2);
free_pos_of_constraints(index_constraint1, 1) = free_pos_of_constraints(index_constraint1, 1) - 1;
free_pos_of_constraints(index_constraint2, 2) = free_pos_of_constraints(index_constraint2, 2) - 1;
% for i = 2:edges
%     edge_weight = sortrows(edge_weight, 1);
%     for j = 1:edges
%         if free_pos_of_constraints(solution(j,1), 1) < free_pos_of_constraints(solution(j,2), 2)
%             edge_weight(j, 2) = free_pos_of_constraints(solution(j,1), 1)  - (1 / (2+p));
%         elseif free_pos_of_constraints(solution(j,1), 1) == free_pos_of_constraints(solution(j,2), 2)
%             edge_weight(j, 2) = free_pos_of_constraints(solution(j,1), 1) - (1 / (1+p));
%         else
%             edge_weight(j, 2) = free_pos_of_constraints(solution(j,2), 2);
%         end
%     end
%     for j = 1:edges
%         if edge_stack(j,1) > 0
%             edge_weight(edge_stack(j,1),2) = power(2*p,2);
%         end
%     end
%     edge_weight = sortrows(edge_weight, 2);
%     
%     edge = edge_weight(1, 1);
%     edge_stack(i, 1) = edge;
%     
%     index_constraint1 = solution(edge,1);
%     index_constraint2 = solution(edge,2);
%     free_pos_of_constraints(index_constraint1, 1) = free_pos_of_constraints(index_constraint1, 1) - 1;
%     free_pos_of_constraints(index_constraint2, 2) = free_pos_of_constraints(index_constraint2, 2) - 1;
% end
edge_stack = constraint1';

iter = 0;
edge = 1;
unsing_tarable = 0;
while edge <= edges  %not all squares filled
    k = edge_stack(edge);
    bank = 0;
    while 1
        bank = bank + 1;
        if bank > p
            bank = 0;
            while 1
                bank = bank + 1;
                if ~any(memory(solution(k,1), bank))        % constraint1
                    unsing_tarable = unsing_tarable + 1;
                    new_collision_edge = k;
                    bank2 = bank;
                    edges_of_constraint2 = constraint2(solution(new_collision_edge,2), :);
                    banks_of_constraint2 = solution(edges_of_constraint2, 3);
                    for i = 1:p
                        if isempty(banks_of_constraint2(banks_of_constraint2 == i))
                            bank2 = i;
                        end
                    end
                    while 1
                        if new_collision_edge == 0
                            break;
                        end 
                        collision_edge = new_collision_edge;
                        solution(collision_edge, 3) = bank;
                        memory(solution(collision_edge,1), bank) = collision_edge;
                        
                        edges_of_constraint2 = constraint2(solution(collision_edge,2), :);
                        edges_of_constraint2 = edges_of_constraint2(edges_of_constraint2 ~= collision_edge);
                        banks_of_constraint2 = solution(edges_of_constraint2, 3);
                        collision_edge = edges_of_constraint2(banks_of_constraint2 == bank);
                        if isempty(collision_edge)
                            break;
                        elseif size(collision_edge, 2) ~= 1
                            edge
                            collision_edge
                        end
                        new_collision_edge = memory(solution(collision_edge,1), bank2);
                        memory(solution(collision_edge,1), solution(collision_edge,3)) = 0;
                        solution(collision_edge, 3) = bank2;
                        memory(solution(collision_edge,1), bank2) = collision_edge;
                    end
                    edge = edge + 1;
                    break;
                end
            end
            break;
        end
        if ~any(memory(solution(k,1), bank))        % constraint1
            edgees_in_constraint = constraint2(solution(k,2), :);
            banks = solution(edgees_in_constraint, 3);
            if isempty(find(banks == bank))         % constraint2
                memory(solution(k,1), bank) = k;
                solution(k, 3) = bank;
                edge = edge + 1;
                break;
            end
        end
    end
end
for i = 1:l
    temp = solution(constraint2(i,:),3);
    temp = temp(temp ~= 0);
    if size(temp,1) ~= size(unique(temp),1)
        i
    end
end
for i = 1:l
    temp = solution(constraint1(i,:),3);
    temp = temp(temp ~= 0);
    if size(temp,1) ~= size(unique(temp),1)
        i
    end
end
unsing_tarable
end
