LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE delays IS 
    constant DURATION_PERMUTATION	: integer := 1;
    constant DURATION_MEM_ACCESS	: integer := 1;
    constant DURATION_CN			: integer := 4;										
    constant DURATION_SN_OUTPUT		: integer := DURATION_MEM_ACCESS + 1;
    constant DURATION_PARTIAL_SUM_CALCULATION : integer := 2;

    constant DELAY_SN				: integer := 1;
    constant DELAY_PERMUTATION_2	: integer := (DELAY_SN + DURATION_SN_OUTPUT);
    constant DELAY_PERMUTATION_0	: integer := (DELAY_PERMUTATION_2 + DURATION_PERMUTATION);
    constant DELAY_PERMUTATION_1	: integer := (DURATION_CN + DURATION_PERMUTATION);						
    constant DELAY_PERMUTATION_3	: integer := (DURATION_CN + 3 * DURATION_PERMUTATION + DURATION_PARTIAL_SUM_CALCULATION);

    constant DELAY_CN 				: integer := (DELAY_SN + DURATION_SN_OUTPUT + 2 * DURATION_PERMUTATION);
    constant DELAY_NEW_SD 			: integer := (DURATION_SN_OUTPUT + 3 * DURATION_PERMUTATION + DURATION_CN);
	
	CONSTANT DELAY_READ_WRITE 		: integer := 4;
	constant WIDTH_ITERATION		: integer := 9;
	constant MAX_ITERATION			: integer := 100;
END delays;