-- Filename    : ShiftRegister.vhd
-- Author:	   : Andreas Torno
-- Description : Generic shift register with fixed length (known at the compile time)

library ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY ShiftRegister IS
	GENERIC (
		size 		: integer := 1;
		width 		: integer := 32
	);
	
    PORT (
		-- Control ports
		clock		: IN std_logic;
		enable		: IN std_logic;
		reset		: IN std_logic;
		
		-- Data ports
        input     	: IN std_logic_vector(width-1 downto 0);
        output    	: OUT std_logic_vector(width-1 downto 0)
    );

END ShiftRegister;

ARCHITECTURE RTL OF ShiftRegister IS
	type shift_type is array(size-1 downto 0) of std_logic_vector(width-1 downto 0);
	signal 		registers		: shift_type;
	constant 	lastElement		: integer 		:= size - 1;
BEGIN
	process(clock)
    begin
	if clock'event and clock='1' then
		-- if reset = '1' then
			-- for i in 0 to lastElement LOOP
				-- registers(i) <= (others => '0'); 
			-- end LOOP;
	    -- elsif enable = '1' then
			registers(0) <= input;
			for i in 1 to lastElement LOOP
				registers(i) <= registers(i - 1); 
			end LOOP;
	    -- end if;
	end if;
    end process;
	
	output <= registers(size - 1);
END RTL;
